<script>
import ReSidebar from "@/components/ReSidebar.vue";
import Select from "@/components/Select.vue";
import SvgIcon from "@/components/SvgIcon.vue";
import Chassis from "@/components/setting/Chassis.vue";
import Audio from "@/components/setting/Audio.vue";
import Screen from "@/components/setting/Screen.vue";

const requireComponent = require.context(
  "@/components/setting",
  false,
  /\.vue$/
);
const cmps = {};
const filterCmps = []; //需要排除引用文件使用

requireComponent.keys().forEach((fileName) => {
  let cmp = requireComponent(fileName).default;
  !filterCmps.includes(fileName) && (cmps[cmp.name] = cmp);
});
console.log(cmps);

export default {
  name: "SettingView",
  components: {
    Chassis,
    Screen,
    Audio,
    ReSidebar,
    Select,
    SvgIcon,
    ...cmps,
  },
  data() {
    return {
      show_menage_icon: true,
      tingche: false,
      reLocation: true,
      clairvoyance: true,
      selectOptions: {
        first: ["标准", "较大"],
        second: ["标准", "动态"],
        third: ["舒适", "运动"],
        fourth: ["舒适", "运动"],
      },
      selectedIndex: {
        first: 0,
        second: 0,
        third: 0,
        fourth: 0,
      },
      sideList: [
        {
          name: "DiLink",
          icon: "ic_dilink",
        },
        {
          name: "DiPilot",
          icon: "ic_dipilot",
        },
        {
          name: "新能源",
          icon: "ic_new_power",
        },
        {
          name: "车辆设置",
          icon: "ic_setting",
        },
        {
          name: "车辆健康",
          icon: "ic_healthy",
        },
      ],
      activeIndex: 0,
      tabItems1: [
        { id: 1, name: "互联" },
        { id: 2, name: "音响" },
        { id: 3, name: "云控" },
        { id: 4, name: "显示" },
        { id: 5, name: "版本管理" },
        { id: 6, name: "应用管理" },
        { id: 7, name: "更多" },
      ],
      tabItems2: [
        { id: 1, name: "驾驶辅助" },
        { id: 2, name: "主动安全" },
        { id: 3, name: "泊车辅助" },
      ],
      tabItems3: [
        { id: 1, name: "能量管理" },
        { id: 2, name: "充电设置" },
        { id: 3, name: "能耗清单" },
        { id: 4, name: "耗能曲线" },
      ],
      tabItems4: [
        { id: 1, name: "智能底盘" },
        { id: 2, name: "灯光和氛围" },
        { id: 3, name: "外后视镜" },
        { id: 4, name: "迎宾" },
        { id: 5, name: "空调" },
        { id: 6, name: "座椅" },
        { id: 7, name: "门窗和锁" },
        { id: 8, name: "智能提醒" },
      ],
      tabItems5: [
        { id: 1, name: "智能保养" },
        { id: 2, name: "检修" },
        { id: 3, name: "车辆信息", disable: true },
      ],
      selectedTab: 0,
      selectedTab1: 0,
      selectedTab2: 0,
      selectedTab3: 0,
      selectedTab4: 0,
    };
  },
  methods: {
    handleSideClick(item, index) {
      this.activeIndex = index;
    },
    handleTabsClick(item) {
      console.log(item);
    },
    changeSelectIndex(index, data) {
      if (data === "first") {
        this.show_menage_icon = index[0] === 0;
      }
      console.log(index[0], data);
      this.selectedIndex[data] = index[0];
    },
  },
  mounted() {
    console.log(this.$route.query, "传值参数");
    this.activeIndex = Number(this.$route.query.activeId) || 0;
    if (this.$route.query.subActiveId) {
      this.selectedTab3 = Number(this.$route.query.subActiveId);
    }
    if (this.$route.query.subActiveIds)
      this.selectedTab1 = Number(this.$route.query.subActiveIds);
    if (this.$route.query.subActiveIdss)
      this.selectedTab4 = Number(this.$route.query.subActiveIdss);
    if (this.$route.query.subActiveIdsss)
      this.selectedTab2 = Number(this.$route.query.subActiveIdsss);
    if (this.$route.query.subActiveIdssss)
      this.selectedTab = Number(this.$route.query.subActiveIdssss);
  },
};
</script>

<template>
  <div class="setting">
    <div class="setting-container">
      <div class="setting-side">
        <div class="setting-side-warp">
          <ReSidebar
            :side-bar-list="sideList"
            :active-index="activeIndex"
            @click="handleSideClick"
          />
        </div>
      </div>
      <div class="setting-main">
        <u-tabs
          v-if="activeIndex === 0"
          v-model="selectedTab"
          :tabsData="tabItems1"
          @item-click="handleTabsClick"
        >
          <template #1>
            <HuLian />
          </template>
          <template #2>
            <Audio />
          </template>
          <template #3>
            <div class="custom-body-3">
              <div class="card-container">
                <u-card shadow left-text="千里眼">
                  <template #right>
                    <u-switch v-model="clairvoyance" :value="clairvoyance" />
                  </template>
                </u-card>
                <u-card shadow left-text="远程位置" leftIconName="setting_tips">
                  <template #right>
                    <u-switch v-model="reLocation" :value="reLocation" />
                  </template>
                </u-card>
              </div>

              <img src="../../assets/images/setting/img_5.webp" alt="" />
            </div>
          </template>
          <template #4>
            <Screen />
          </template>
          <template #5>
            <Version />
          </template>
          <template #6>
            <Application />
          </template>
          <template #7>
            <More />
          </template>
        </u-tabs>

        <u-tabs
          v-if="activeIndex === 1"
          v-model="selectedTab1"
          :tabsData="tabItems2"
          @item-click="handleTabsClick"
        >
          <template #1>
            <DrivingAssist />
          </template>
          <template #2>
            <Safety />
          </template>
          <template #3>
            <Parking />
          </template>
        </u-tabs>

        <u-tabs
          v-if="activeIndex === 2"
          v-model="selectedTab2"
          :tabsData="tabItems3"
          @item-click="handleTabsClick"
        >
          <template #1>
            <EnergyFeed />
          </template>
          <template #2>
            <encharge />
          </template>
          <template #3>
            <EnergyList />
          </template>
          <template #4>
            <EnergyCurve />
          </template>
        </u-tabs>

        <u-tabs
          v-if="activeIndex === 3"
          v-model="selectedTab3"
          :tabsData="tabItems4"
          @item-click="handleTabsClick"
        >
          <template #1>
            <chassis />
          </template>
          <template #2>
            <Light />
          </template>
          <template #3>
            <Mirror :type="1" />
          </template>
          <template #4>
            <Mirror :type="2" />
          </template>
          <template #5>
            <Air />
          </template>
          <template #6>
            <Seat />
          </template>
          <template #7>
            <WindowAndLock />
          </template>
          <template #8>
            <Reminder />
          </template>
        </u-tabs>

        <u-tabs
          v-if="activeIndex === 4"
          v-model="selectedTab4"
          :tabsData="tabItems5"
          @item-click="handleTabsClick"
        >
          <template #1>
            <Maintenance />
          </template>
          <template #2>
            <Repair />
          </template>
        </u-tabs>
      </div>
    </div>
  </div>
</template>

<style scoped lang="scss">
.custom-body-3 {
  width: 100%;
  position: relative;
  display: flex;

  .card-container {
    width: 691px;
    margin-bottom: 15px;
  }

  img {
    position: absolute;
    left: 735px;
    top: 57px;
    width: 823px;
    height: 595px;
  }
}

.dilink-15 {
  position: relative;

  .dilink-15-img {
    width: 950px;
    height: 653px;
    position: absolute;
    right: 0;
    top: 140px;
  }

  .select-body {
    width: 688px;

    .card-container {
      margin-bottom: 14px;
    }

    .select-group {
      width: 688px;
      border-radius: 16px;
      box-shadow: 0 0 10px 3px rgba(0, 0, 0, 0.09);
      background: #ffffff;
      display: flex;
      flex-direction: column;
      padding: 39px 42px 45px 44px;
      box-sizing: border-box;
      margin-bottom: 14px;

      .select-title {
        font-size: 28px;
        font-weight: 400;
        color: #090909;
        line-height: 33px;
        letter-spacing: 1px;
      }

      .slecet-warp {
        width: 602px;
        height: 68px;
        margin-top: 25px;
      }

      .select-switch {
        margin-top: 57px;
        width: 602px;
        display: flex;
        justify-content: space-between;

        .title {
          font-size: 28px;
          font-weight: 400;
          color: #090909;
          line-height: 33px;
          letter-spacing: 1px;
        }
      }
    }
  }
}

.setting {
  height: 100%;
  background: #f0f3f7;
  box-sizing: border-box;
  padding-top: 46px;

  &-container {
    height: 100%;
    display: flex;
  }

  &-side {
    height: calc(100% - 90px);
    margin-top: 44px;
    background: #f6f8fa;
  }

  .setting-side-warp {
    height: 875px;
  }

  &-main {
    flex: 1;
    padding: 80px 40px;
  }
}
</style>
